package StonedMario;

import ea.*;
//import java.awt.Toolkit;
import java.util.Random;
/*
 * Die Klasse StonedMario erbt von der Klasse Game und ist die spielsteuernde Klasse für das Spiel.
 */
public class StonedMario
//extends Game
extends Knoten
implements Ticker, TastenLosgelassenReagierbar
{
    private MARIO stonedmario;
    private Manager manager;
    private MAUER[] grenzen = new MAUER[300];
    private MAUER[] hindernisse = new MAUER[16]; 
    private Random zufall;
    private MAUERKNOTEN mknoten;
    private int punkte;
    private Text punkteanzeige;
    private int[] highscore = new int[10];
    private boolean laufend;
    private Text i,ii, iii;
    public SOUND soundG;
    private Bild hintergrund;
    
    private final String sep=System.getProperty("file.separator");
    private final Game spiel;
    private int music;
    /**
     * Der Konstruktor erstellt ein neues Fenster der Maße 640,635), und dazu noch das Spielfeld mit den Hindernissen,Grenzen und der Figur.
     * 
     * 
     * Parameter:
     * x: Die x-Koordinate der linken oberen Ecke der Figur.
     * y: Die y-Koordinate der linken oberen Ecke der Figur.
     * hintergrundpfad: der Dateipfad des Hintergrundbilds (wenn keiner mitgegeben wird, ist der Hintergrund schwarz). 
     * figurpfad: der Dateipfad des Figurbilds.
     */
    public StonedMario(Game spiel, int music)
    {
        //super (0,0, "StonedMario", false, true,0, 0 );
        
        this.spiel = spiel;
        this.music = music;
        
        int x=300, y=300;
        
        
        soundG= new SOUND("Sound"+sep+"Musik"+sep+"Pamgaea.wav");
        
        if(music == 1)
        {
            spiel.audioManager.abspielen(soundG, true);
        }
        
        //hintergrund = new Bild(0,0,10000,200000,"StonedMario"+sep+"Hintergrund.gif",true);
        hintergrund= new Bild(0,0,1280,720,"StonedMario"+sep+"schwarz.gif",false);
        
        //         if(hintergrundpfad == "StonedMario"+sep+"Hintergrund.gif")
        //         {     hintergrund = new Bild(0,0,10000,200000,hintergrundpfad,true);
        //         }
        //         else{
        //             //hintergrund= new Bild(0,0,Toolkit.getDefaultToolkit().getScreenSize().width,Toolkit.getDefaultToolkit().getScreenSize().height,hintergrundpfad,false);
        //             hintergrund= new Bild(0,0,1280,720,hintergrundpfad,false);
        //         }
        this.add(hintergrund);
        
        laufend=true;
        highscore=DateiManager.integerArrayEinlesen("StonedMario"+sep+"highscore.eaa");
        punkte=0;
        punkteanzeige= new Text("0",30,30);
        punkteanzeige.setzeFarbe("rot");
        mknoten=new MAUERKNOTEN();
        zufall= new Random ();
        stonedmario=new MARIO (x,y,"StonedMario"+sep+"MarioFigur.eaf");
        manager= new Manager();
        manager.anmelden(this,20);
        //         super.tastenReagierbarAnmelden(this);
        //         super.tastenLosgelassenReagierbarAnmelden(this);
        int xko=0;
        int yko=0;
        for (int i=0; i<300; i++)
        {
            if (i==150)
            {
                //yko= Toolkit.getDefaultToolkit().getScreenSize().height -10; 
                yko= 710; 
                xko=0;
            }
            grenzen[i]= new MAUER(xko,yko,10,10);
            grenzen[i].farbeSetzen("blau");
            xko=xko+10;
            this.add(grenzen[i]);
        }
        this.add(stonedmario);
        int breite = 2;
        int hoehe = 350;
        int kox = 640;
        int koy = 0;
        for (int i=0; i<16; i++)
        {
            if(i==0 || i==2 || i==4 || i==6 || i==8 || i==10 || i==12 || i==14 || i==16)
            {
                koy = zufall.nextInt(600);
                while (koy<100)
                {  koy=zufall.nextInt(600);
                }
                hindernisse[i]= new MAUER (kox,koy,breite,hoehe);
                hindernisse[i].farbeSetzen("blau");
                mknoten.add(hindernisse[i]); 
                this.add(hindernisse[i]);
                koy= koy-700;
            }
            else if (i==1)
            {
                kox= hindernisse[0].gibX();
                hindernisse[i]= new MAUER (kox,koy,breite,hoehe);
                mknoten.add(hindernisse[i]);
                this.add(hindernisse[i]);
                hindernisse[i].farbeSetzen("blau");
                kox=kox+160;
            }
            else if (i==3)
            {
                kox= hindernisse[2].gibX();
                hindernisse[i]= new MAUER (kox,koy,breite,hoehe);
                mknoten.add(hindernisse[i]);
                this.add(hindernisse[i]);
                hindernisse[i].farbeSetzen("blau");
                kox=kox+160;
            }
            else if (i==5)
            {
                kox= hindernisse[4].gibX();
                hindernisse[i]= new MAUER (kox,koy,breite,hoehe);
                mknoten.add(hindernisse[i]);
                this.add(hindernisse[i]);
                hindernisse[i].farbeSetzen("blau");
                kox=kox+160;
            }
            else if (i==7)
            {
                kox= hindernisse[6].gibX();
                hindernisse[i]= new MAUER (kox,koy,breite,hoehe);
                mknoten.add(hindernisse[i]);
                this.add(hindernisse[i]);
                hindernisse[i].farbeSetzen("blau");
                kox=kox+160;
            }
            else if (i==9)
            {
                kox= hindernisse[8].gibX();
                hindernisse[i]= new MAUER (kox,koy,breite,hoehe);
                mknoten.add(hindernisse[i]);
                this.add(hindernisse[i]);
                hindernisse[i].farbeSetzen("blau");
                kox=kox+160;
            }
            else if (i==11)
            {
                kox= hindernisse[10].gibX();
                hindernisse[i]= new MAUER (kox,koy,breite,hoehe);
                mknoten.add(hindernisse[i]);
                this.add(hindernisse[i]);
                hindernisse[i].farbeSetzen("blau");
                kox=kox+160;
            }
            else if (i==13)
            {
                kox= hindernisse[12].gibX();
                hindernisse[i]= new MAUER (kox,koy,breite,hoehe);
                mknoten.add(hindernisse[i]);
                this.add(hindernisse[i]);
                hindernisse[i].farbeSetzen("blau");
                kox=kox+160;
            }
            else if (i==15)
            {
                kox= hindernisse[14].gibX();
                hindernisse[i]= new MAUER (kox,koy,breite,hoehe);
                mknoten.add(hindernisse[i]);
                this.add(hindernisse[i]);
                hindernisse[i].farbeSetzen("blau");
                kox=kox+160;
            }
        }

        this.add(punkteanzeige);

    }

    /*
     * Die Methode wird aufgerufen, wenn eine Taste gedrückt wird.
     * Die Methode wird einerseits zur Bewegung nach oben benutzt, andererseits für das erneute Spielen, nach einer Niederlage.
     * 
     * Parameter:
     * code: die Tastennummer, die gedrückt wird.
     */
    public void tasteReagieren(int code)
    {
        if (code == 30)
        {
            stonedmario.geschwindigkeitSetzen(-4);                     

        }
        if (code == 4 && laufend==false)
        {
            int breite = 2;
            int hoehe = 350;
            int kox = 640;
            int koy = 0;
            stonedmario.animationsGeschwindigkeitSetzen(100);
            for (int i=0; i<16; i++)
            {
                if(i==0 || i==2 || i==4 || i==6 || i==8 || i==10 || i==12 || i==14 || i==16)
                {
                    koy = zufall.nextInt(600);
                    while (koy<100)
                    {  koy=zufall.nextInt(600);
                    }
                    hindernisse[i].positionSetzen(kox,koy);
                    koy= koy-700;
                    hindernisse[i+1].positionSetzen(kox,koy);
                    kox=kox+160;
                }
            }
            stonedmario.mittelpunktSetzen(300,300);
            punkte=0;
            punkteanzeige.inhaltSetzen("0");
            laufend=true;
            this.entfernen(ii);
            this.entfernen(i);
            manager.anmelden(this,20);
            
            
            if(music == 1)
            {
                spiel.audioManager.abspielen(soundG, true);
            }
        }
    }

    public void tasteLosgelassen (int code)
    {
        if (code == 30)
        {
            stonedmario.geschwindigkeitSetzen(6);
        }
    }

    public void tick ()
    {
        if (alleskollidiert()==true)
        {
            manager.abmelden(this);
            stonedmario.animationsGeschwindigkeitSetzen(1000000000);
            
            if(music == 1)
            {
                spiel.audioManager.anhalten(soundG);
            }
            
            if (punkte>highscore[0])
            {    highscore[9]=highscore[8];   
                highscore[8]=highscore[7];
                highscore[7]=highscore[6];
                highscore[6]=highscore[5];
                highscore[5]=highscore[4];
                highscore[4]=highscore[3];
                highscore[3]=highscore[2];
                highscore[2]=highscore[1];
                highscore[1]=highscore[0];
                highscore[0]=punkte;
            }
            else if (punkte>highscore[1])
            {    highscore[9]=highscore[8];   
                highscore[8]=highscore[7];
                highscore[7]=highscore[6];
                highscore[6]=highscore[5];
                highscore[5]=highscore[4];
                highscore[4]=highscore[3];
                highscore[3]=highscore[2];
                highscore[2]=highscore[1];
                highscore[1]=punkte;
            }
            else if (punkte>highscore[2])
            {    highscore[9]=highscore[8];   
                highscore[8]=highscore[7];
                highscore[7]=highscore[6];
                highscore[6]=highscore[5];
                highscore[5]=highscore[4];
                highscore[4]=highscore[3];
                highscore[3]=highscore[2];
                highscore[2]=punkte;
            }
            else if (punkte>highscore[3])
            {    highscore[9]=highscore[8];   
                highscore[8]=highscore[7];
                highscore[7]=highscore[6];
                highscore[6]=highscore[5];
                highscore[5]=highscore[4];
                highscore[4]=highscore[3];
                highscore[3]=punkte;
            }
            else if (punkte>highscore[4])
            {    highscore[9]=highscore[8];   
                highscore[8]=highscore[7];
                highscore[7]=highscore[6];
                highscore[6]=highscore[5];
                highscore[5]=highscore[4];
                highscore[4]=punkte;
            }
            else if (punkte>highscore[5])
            {    highscore[9]=highscore[8];   
                highscore[8]=highscore[7];
                highscore[7]=highscore[6];
                highscore[6]=highscore[5];
                highscore[5]=punkte;
            }
            else if (punkte>highscore[6])
            {    highscore[9]=highscore[8];   
                highscore[8]=highscore[7];
                highscore[7]=highscore[6];
                highscore[6]=punkte;
            }
            else if (punkte>highscore[7])
            {    highscore[9]=highscore[8];   
                highscore[8]=highscore[7];
                highscore[7]=punkte;
            }
            else if (punkte>highscore[8])
            {    highscore[9]=highscore[8];   
                highscore[8]=punkte;
            }
            else if (punkte>highscore[9])
            {    highscore[9]=punkte;
            } 
            else{
            }
            DateiManager.integerArraySchreiben(highscore,"StonedMario"+sep+"highscore.eaa");
            i= new Text("Nochmal? E drücken!",510,350);
            i.mittelpunktSetzen(640, 350);
            ii=new Text("GAME OVER",550,300);
            ii.mittelpunktSetzen(640, 300);
            iii=new Text("Zurück zum Hauptspiel? Esc drücken!", 0, 0);
            iii.mittelpunktSetzen(640, 400);
            ii.farbeSetzen("blau");
            ii.groesseSetzen(35);
            i.farbeSetzen("blau");
            i.groesseSetzen(30);
            iii.farbeSetzen("blau");
            iii.groesseSetzen(30);
            this.add(i, ii, iii);
            laufend=false;
        }
        else
        {
            for (int i =0;i<16;i++)
            {
                if(i==0 || i==2 || i==4 || i==6 || i==8 || i==10 || i==12 || i==14 || i==16)
                {
                    hindernisse[i].fallrueckzieher();
                    hindernisse[i+1].positionSetzen(hindernisse[i].gibX(), hindernisse[i].gibY()-700);
                }
            }
            stonedmario.bewegen();
            mknoten.bewegen(new Vektor(-1,0));
            for (int i=0;i<16;i++)
            {
                if(i==0 || i==2 || i==4 || i==6 || i==8 || i==10 || i==12 || i==14 || i==16){
                    if (hindernisse[i].gibX() == stonedmario.gibX())
                    {  punkte=punkte+1;
                        punkteanzeige.setzeInhalt(""+punkte);
                    }
                }
            }
        }
    }

    public boolean alleskollidiert ()
    {
        boolean wahr = false;
        for (int i=0;i<16;i++)
        {
            if(hindernisse[i].kollidiert(stonedmario)==true)
            {    wahr=true;
            }
        }
        for (int i=0;i<300;i++)
        {
            if(grenzen[i].kollidiert(stonedmario)==true)
            {    wahr=true;
            }
        }

        return wahr;
    }

    public void nichtAusfuehren()
    {   for(int i=0;i<10;i++)
        {   highscore[i]=0;
        }
    }

}
